## xgboost 1.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
project(xgboost LANGUAGES CXX C VERSION 1.7.1)
include(cmake/Utils.cmake)
list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")
cmake_policy(SET CMP0022 NEW)
cmake_policy(SET CMP0079 NEW)
cmake_policy(SET CMP0076 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0063 NEW)
cmake_policy(SET CMP0063 NEW)

if ((${CMAKE_VERSION} VERSION_GREATER 3.13) OR (${CMAKE_VERSION} VERSION_EQUAL 3.13))
  cmake_policy(SET CMP0077 NEW)
endif ((${CMAKE_VERSION} VERSION_GREATER 3.13) OR (${CMAKE_VERSION} VERSION_EQUAL 3.13))

message(STATUS "CMake version ${CMAKE_VERSION}")

if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
  message(FATAL_ERROR "GCC version must be at least 5.0!")
endif()

include(${xgboost_SOURCE_DIR}/cmake/FindPrefetchIntrinsics.cmake)
find_prefetch_intrinsics()
include(${xgboost_SOURCE_DIR}/cmake/Version.cmake)
write_version()
set_default_configuration_release()

#-- Options
## User options
option(BUILD_C_DOC "Build documentation for C APIs using Doxygen." OFF)
option(USE_OPENMP "Build with OpenMP support." ON)
option(BUILD_STATIC_LIB "Build static library" OFF)
option(FORCE_SHARED_CRT "Build with dynamic CRT on Windows (/MD)" OFF)
option(RABIT_BUILD_MPI "Build MPI" OFF)
## Bindings
option(JVM_BINDINGS "Build JVM bindings" OFF)
option(R_LIB "Build shared library for R package" OFF)
## Dev
option(USE_DEBUG_OUTPUT "Dump internal training results like gradients and predictions to stdout.
Should only be used for debugging." OFF)
option(FORCE_COLORED_OUTPUT "Force colored output from compilers, useful when ninja is used instead of make." OFF)
option(ENABLE_ALL_WARNINGS "Enable all compiler warnings. Only effective for GCC/Clang" OFF)
option(LOG_CAPI_INVOCATION "Log all C API invocations for debugging" OFF)
option(GOOGLE_TEST "Build google tests" OFF)
option(USE_DMLC_GTEST "Use google tests bundled with dmlc-core submodule" OFF)
option(USE_DEVICE_DEBUG "Generate CUDA device debug info." OFF)
option(USE_NVTX "Build with cuda profiling annotations. Developers only." OFF)
set(NVTX_HEADER_DIR "" CACHE PATH "Path to the stand-alone nvtx header")
option(RABIT_MOCK "Build rabit with mock" OFF)
option(HIDE_CXX_SYMBOLS "Build shared library and hide all C++ symbols" OFF)
## CUDA
option(USE_CUDA  "Build with GPU acceleration" OFF)
option(USE_NCCL  "Build with NCCL to enable distributed GPU support." OFF)
option(BUILD_WITH_SHARED_NCCL "Build with shared NCCL library." OFF)
option(BUILD_WITH_CUDA_CUB "Build with cub in CUDA installation" OFF)
set(GPU_COMPUTE_VER "" CACHE STRING
  "Semicolon separated list of compute versions to be built against, e.g. '35;61'")
## Copied From dmlc
option(USE_HDFS "Build with HDFS support" OFF)
option(USE_AZURE "Build with AZURE support" OFF)
option(USE_S3 "Build with S3 support" OFF)
## Sanitizers
option(USE_SANITIZER "Use santizer flags" OFF)
option(SANITIZER_PATH "Path to sanitizes.")
set(ENABLED_SANITIZERS "address" "leak" CACHE STRING
  "Semicolon separated list of sanitizer names. E.g 'address;leak'. Supported sanitizers are
address, leak, undefined and thread.")
## Plugins
option(PLUGIN_DENSE_PARSER "Build dense parser plugin" OFF)
option(PLUGIN_RMM "Build with RAPIDS Memory Manager (RMM)" OFF)
option(PLUGIN_FEDERATED "Build with Federated Learning" OFF)
## TODO: 1. Add check if DPC++ compiler is used for building
option(PLUGIN_UPDATER_ONEAPI "DPC++ updater" OFF)
option(ADD_PKGCONFIG "Add xgboost.pc into system." ON)

#-- Checks for building XGBoost
if (USE_DEBUG_OUTPUT AND (NOT (CMAKE_BUILD_TYPE MATCHES Debug)))
  message(SEND_ERROR "Do not enable `USE_DEBUG_OUTPUT' with release build.")
endif (USE_DEBUG_OUTPUT AND (NOT (CMAKE_BUILD_TYPE MATCHES Debug)))
if (USE_NCCL AND NOT (USE_CUDA))
  message(SEND_ERROR "`USE_NCCL` must be enabled with `USE_CUDA` flag.")
endif (USE_NCCL AND NOT (USE_CUDA))
if (USE_DEVICE_DEBUG AND NOT (USE_CUDA))
  message(SEND_ERROR "`USE_DEVICE_DEBUG` must be enabled with `USE_CUDA` flag.")
endif (USE_DEVICE_DEBUG AND NOT (USE_CUDA))
if (BUILD_WITH_SHARED_NCCL AND (NOT USE_NCCL))
  message(SEND_ERROR "Build XGBoost with -DUSE_NCCL=ON to enable BUILD_WITH_SHARED_NCCL.")
endif (BUILD_WITH_SHARED_NCCL AND (NOT USE_NCCL))
if (JVM_BINDINGS AND R_LIB)
  message(SEND_ERROR "`R_LIB' is not compatible with `JVM_BINDINGS' as they both have customized configurations.")
endif (JVM_BINDINGS AND R_LIB)
if (R_LIB AND GOOGLE_TEST)
  message(WARNING "Some C++ unittests will fail with `R_LIB` enabled,
 as R package redirects some functions to R runtime implementation.")
endif (R_LIB AND GOOGLE_TEST)
if (USE_AVX)
  message(SEND_ERROR  "The option 'USE_AVX' is deprecated as experimental AVX features have been removed from XGBoost.")
endif (USE_AVX)
if (PLUGIN_LZ4)
  message(SEND_ERROR  "The option 'PLUGIN_LZ4' is removed from XGBoost.")
endif (PLUGIN_LZ4)
if (PLUGIN_RMM AND NOT (USE_CUDA))
  message(SEND_ERROR "`PLUGIN_RMM` must be enabled with `USE_CUDA` flag.")
endif (PLUGIN_RMM AND NOT (USE_CUDA))
if (PLUGIN_RMM AND NOT ((CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")))
  message(SEND_ERROR "`PLUGIN_RMM` must be used with GCC or Clang compiler.")
endif (PLUGIN_RMM AND NOT ((CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")))
if (PLUGIN_RMM AND NOT (CMAKE_SYSTEM_NAME STREQUAL "Linux"))
  message(SEND_ERROR "`PLUGIN_RMM` must be used with Linux.")
endif (PLUGIN_RMM AND NOT (CMAKE_SYSTEM_NAME STREQUAL "Linux"))
if (ENABLE_ALL_WARNINGS)
  if ((NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang") AND (NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU"))
    message(SEND_ERROR "ENABLE_ALL_WARNINGS is only available for Clang and GCC.")
  endif ((NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang") AND (NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU"))
endif (ENABLE_ALL_WARNINGS)
if (BUILD_STATIC_LIB AND (R_LIB OR JVM_BINDINGS))
  message(SEND_ERROR "Cannot build a static library libxgboost.a when R or JVM packages are enabled.")
endif (BUILD_STATIC_LIB AND (R_LIB OR JVM_BINDINGS))
if (PLUGIN_RMM AND (NOT BUILD_WITH_CUDA_CUB))
  message(SEND_ERROR "Cannot build with RMM using cub submodule.")
endif (PLUGIN_RMM AND (NOT BUILD_WITH_CUDA_CUB))
if (PLUGIN_FEDERATED)
  if (CMAKE_CROSSCOMPILING)
    message(SEND_ERROR "Cannot cross compile with federated learning support")
  endif ()
  if (BUILD_STATIC_LIB)
    message(SEND_ERROR "Cannot build static lib with federated learning support")
  endif ()
  if (R_LIB OR JVM_BINDINGS)
    message(SEND_ERROR "Cannot enable federated learning support when R or JVM packages are enabled.")
  endif ()
  if (WIN32)
    message(SEND_ERROR "Federated learning not supported for Windows platform")
  endif ()
endif ()

#-- Sanitizer
if (USE_SANITIZER)
  include(cmake/Sanitizer.cmake)
  enable_sanitizers("${ENABLED_SANITIZERS}")
endif (USE_SANITIZER)

if (USE_CUDA)
  set(USE_OPENMP ON CACHE BOOL "CUDA requires OpenMP" FORCE)
  # `export CXX=' is ignored by CMake CUDA.
  set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
  message(STATUS "Configured CUDA host compiler: ${CMAKE_CUDA_HOST_COMPILER}")

  enable_language(CUDA)
  if (${CMAKE_CUDA_COMPILER_VERSION} VERSION_LESS 11.0)
    message(FATAL_ERROR "CUDA version must be at least 11.0!")
  endif()
  set(GEN_CODE "")
  format_gencode_flags("${GPU_COMPUTE_VER}" GEN_CODE)
  add_subdirectory(${PROJECT_SOURCE_DIR}/gputreeshap)

  if ((${CMAKE_CUDA_COMPILER_VERSION} VERSION_GREATER_EQUAL 11.4) AND (NOT BUILD_WITH_CUDA_CUB))
    set(BUILD_WITH_CUDA_CUB ON)
  endif ()
endif (USE_CUDA)

if (FORCE_COLORED_OUTPUT AND (CMAKE_GENERATOR STREQUAL "Ninja") AND
    ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR
      (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")))
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-color=always")
endif()

find_package(Threads REQUIRED)

if (USE_OPENMP)
  if (APPLE)
    # Require CMake 3.16+ on Mac OSX, as previous versions of CMake had trouble locating
    # OpenMP on Mac. See https://github.com/dmlc/xgboost/pull/5146#issuecomment-568312706
    cmake_minimum_required(VERSION 3.16)
    find_package(OpenMP)
    if (NOT OpenMP_FOUND)
      # Try again with extra path info; required for libomp 15+ from Homebrew
      execute_process(COMMAND brew --prefix libomp
                      OUTPUT_VARIABLE HOMEBREW_LIBOMP_PREFIX
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
      set(OpenMP_C_FLAGS
        "-Xpreprocessor -fopenmp -I${HOMEBREW_LIBOMP_PREFIX}/include")
      set(OpenMP_CXX_FLAGS
        "-Xpreprocessor -fopenmp -I${HOMEBREW_LIBOMP_PREFIX}/include")
      set(OpenMP_C_LIB_NAMES omp)
      set(OpenMP_CXX_LIB_NAMES omp)
      set(OpenMP_omp_LIBRARY ${HOMEBREW_LIBOMP_PREFIX}/lib/libomp.dylib)
      find_package(OpenMP REQUIRED)
    endif ()
  else ()
    find_package(OpenMP REQUIRED)
  endif ()
endif (USE_OPENMP)
#Add for IBM i
if (${CMAKE_SYSTEM_NAME} MATCHES "OS400")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  set(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> -X64 qc <TARGET> <OBJECTS>")
endif()

if (USE_NCCL)
  find_package(Nccl REQUIRED)
endif (USE_NCCL)

# dmlc-core
msvc_use_static_runtime()
if (FORCE_SHARED_CRT)
  set(DMLC_FORCE_SHARED_CRT ON)
endif ()
add_subdirectory(${xgboost_SOURCE_DIR}/dmlc-core)

if (MSVC)
  if (TARGET dmlc_unit_tests)
    target_compile_options(dmlc_unit_tests PRIVATE
                           -D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_DEPRECATE)
  endif (TARGET dmlc_unit_tests)
endif (MSVC)

# rabit
add_subdirectory(rabit)
if (RABIT_BUILD_MPI)
  find_package(MPI REQUIRED)
endif (RABIT_BUILD_MPI)

# core xgboost
add_subdirectory(${xgboost_SOURCE_DIR}/src)
target_link_libraries(objxgboost PUBLIC dmlc)

# Exports some R specific definitions and objects
if (R_LIB)
  add_subdirectory(${xgboost_SOURCE_DIR}/R-package)
endif (R_LIB)

# This creates its own shared library `xgboost4j'.
if (JVM_BINDINGS)
  add_subdirectory(${xgboost_SOURCE_DIR}/jvm-packages)
endif (JVM_BINDINGS)

# Plugin
add_subdirectory(${xgboost_SOURCE_DIR}/plugin)

if (PLUGIN_RMM)
  find_package(rmm REQUIRED)
endif (PLUGIN_RMM)

#-- library
if (BUILD_STATIC_LIB)
  add_library(xgboost STATIC)
else (BUILD_STATIC_LIB)
  add_library(xgboost SHARED)
endif (BUILD_STATIC_LIB)
target_link_libraries(xgboost PRIVATE objxgboost)
target_include_directories(xgboost
  INTERFACE
  $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>)
#-- End shared library

#-- CLI for xgboost
add_executable(runxgboost ${xgboost_SOURCE_DIR}/src/cli_main.cc)
target_link_libraries(runxgboost PRIVATE objxgboost)
target_include_directories(runxgboost
  PRIVATE
  ${xgboost_SOURCE_DIR}/include
  ${xgboost_SOURCE_DIR}/dmlc-core/include
  ${xgboost_SOURCE_DIR}/rabit/include
)
set_target_properties(runxgboost PROPERTIES OUTPUT_NAME xgboost)
#-- End CLI for xgboost

# Common setup for all targets
foreach(target xgboost objxgboost dmlc runxgboost)
  xgboost_target_properties(${target})
  xgboost_target_link_libraries(${target})
  xgboost_target_defs(${target})
endforeach()

if (JVM_BINDINGS)
  xgboost_target_properties(xgboost4j)
  xgboost_target_link_libraries(xgboost4j)
  xgboost_target_defs(xgboost4j)
endif (JVM_BINDINGS)

set_output_directory(runxgboost ${xgboost_SOURCE_DIR})
set_output_directory(xgboost ${xgboost_SOURCE_DIR}/lib)
# Ensure these two targets do not build simultaneously, as they produce outputs with conflicting names
add_dependencies(xgboost runxgboost)

#-- Installing XGBoost
if (R_LIB)
  include(cmake/RPackageInstallTargetSetup.cmake)
  set_target_properties(xgboost PROPERTIES PREFIX "")
  if (APPLE)
    set_target_properties(xgboost PROPERTIES SUFFIX ".so")
  endif (APPLE)
  setup_rpackage_install_target(xgboost "${CMAKE_CURRENT_BINARY_DIR}/R-package-install")
  set(CMAKE_INSTALL_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/dummy_inst")
endif (R_LIB)
if (MINGW)
  set_target_properties(xgboost PROPERTIES PREFIX "")
endif (MINGW)

if (BUILD_C_DOC)
  include(cmake/Doc.cmake)
  run_doxygen()
endif (BUILD_C_DOC)

include(CPack)

=== Makefile ===
ifndef DMLC_CORE
	DMLC_CORE = dmlc-core
endif

ifndef RABIT
	RABIT = rabit
endif

ROOTDIR = $(CURDIR)

# workarounds for some buggy old make & msys2 versions seen in windows
ifeq (NA, $(shell test ! -d "$(ROOTDIR)" && echo NA ))
        $(warning Attempting to fix non-existing ROOTDIR [$(ROOTDIR)])
        ROOTDIR := $(shell pwd)
        $(warning New ROOTDIR [$(ROOTDIR)] $(shell test -d "$(ROOTDIR)" && echo " is OK" ))
endif
MAKE_OK := $(shell "$(MAKE)" -v 2> /dev/null)
ifndef MAKE_OK
        $(warning Attempting to recover non-functional MAKE [$(MAKE)])
        MAKE := $(shell which make 2> /dev/null)
        MAKE_OK := $(shell "$(MAKE)" -v 2> /dev/null)
endif
$(warning MAKE [$(MAKE)] - $(if $(MAKE_OK),checked OK,PROBLEM))

include $(DMLC_CORE)/make/dmlc.mk

# set compiler defaults for OSX versus *nix
# let people override either
OS := $(shell uname)
ifeq ($(OS), Darwin)
ifndef CC
export CC = $(if $(shell which clang), clang, gcc)
endif
ifndef CXX
export CXX = $(if $(shell which clang++), clang++, g++)
endif
else
# linux defaults
ifndef CC
export CC = gcc
endif
ifndef CXX
export CXX = g++
endif
endif

export CFLAGS= -DDMLC_LOG_CUSTOMIZE=1 -std=c++14 -Wall -Wno-unknown-pragmas -Iinclude $(ADD_CFLAGS)
CFLAGS += -I$(DMLC_CORE)/include -I$(RABIT)/include -I$(GTEST_PATH)/include

ifeq ($(TEST_COVER), 1)
	CFLAGS += -g -O0 -fprofile-arcs -ftest-coverage
else
	CFLAGS += -O3 -funroll-loops
endif

ifndef LINT_LANG
	LINT_LANG= "all"
endif

# specify tensor path
.PHONY: clean all lint clean_all doxygen rcpplint pypack Rpack Rbuild Rcheck

build/%.o: src/%.cc
	@mkdir -p $(@D)
	$(CXX) $(CFLAGS) -MM -MT build/$*.o $< >build/$*.d
	$(CXX) -c $(CFLAGS) $< -o $@

# The should be equivalent to $(ALL_OBJ)  except for build/cli_main.o
amalgamation/xgboost-all0.o: amalgamation/xgboost-all0.cc
	$(CXX) -c $(CFLAGS) $< -o $@

rcpplint:
	python3 dmlc-core/scripts/lint.py xgboost ${LINT_LANG} R-package/src

lint: rcpplint
	python3 dmlc-core/scripts/lint.py --exclude_path python-package/xgboost/dmlc-core \
	  python-package/xgboost/include python-package/xgboost/lib \
	  python-package/xgboost/make python-package/xgboost/rabit \
	  python-package/xgboost/src --pylint-rc ${PWD}/python-package/.pylintrc xgboost \
	  ${LINT_LANG} include src python-package

ifeq ($(TEST_COVER), 1)
cover: check
	@- $(foreach COV_OBJ, $(COVER_OBJ), \
		gcov -pbcul -o $(shell dirname $(COV_OBJ)) $(COV_OBJ) > gcov.log || cat gcov.log; \
	)
endif


clean:
	$(RM) -rf build lib bin *~ */*~ */*/*~ */*/*/*~ */*.o */*/*.o */*/*/*.o #xgboost
	$(RM) -rf build_tests *.gcov tests/cpp/xgboost_test
	if [ -d "R-package/src" ]; then \
		cd R-package/src; \
		$(RM) -rf rabit src include dmlc-core amalgamation *.so *.dll; \
		cd $(ROOTDIR); \
	fi

clean_all: clean
	cd $(DMLC_CORE); "$(MAKE)" clean; cd $(ROOTDIR)
	cd $(RABIT); "$(MAKE)" clean; cd $(ROOTDIR)

# create pip source dist (sdist) pack for PyPI
pippack: clean_all
	cd python-package; python setup.py sdist; mv dist/*.tar.gz ..; cd ..

# Script to make a clean installable R package.
Rpack: clean_all
	rm -rf xgboost xgboost*.tar.gz
	cp -r R-package xgboost
	rm -rf xgboost/src/*.o xgboost/src/*.so xgboost/src/*.dll
	rm -rf xgboost/src/*/*.o
	rm -rf xgboost/demo/*.model xgboost/demo/*.buffer xgboost/demo/*.txt
	rm -rf xgboost/demo/runall.R
	cp -r src xgboost/src/src
	cp -r include xgboost/src/include
	cp -r amalgamation xgboost/src/amalgamation
	mkdir -p xgboost/src/rabit
	cp -r rabit/include xgboost/src/rabit/include
	cp -r rabit/src xgboost/src/rabit/src
	rm -rf xgboost/src/rabit/src/*.o
	mkdir -p xgboost/src/dmlc-core
	cp -r dmlc-core/include xgboost/src/dmlc-core/include
	cp -r dmlc-core/src xgboost/src/dmlc-core/src
	cp ./LICENSE xgboost
	cat R-package/src/Makevars.in|sed '2s/.*/PKGROOT=./' > xgboost/src/Makevars.in
	cat R-package/src/Makevars.win|sed '2s/.*/PKGROOT=./' > xgboost/src/Makevars.win
	rm -f xgboost/src/Makevars.win-e   # OSX sed create this extra file; remove it
	rm -f xgboost/cleanup
	bash R-package/remove_warning_suppression_pragma.sh
	bash xgboost/remove_warning_suppression_pragma.sh
	rm xgboost/remove_warning_suppression_pragma.sh
	rm xgboost/CMakeLists.txt
	rm -rfv xgboost/tests/helper_scripts/

R ?= R

Rbuild: Rpack
	$(R) CMD build xgboost
	rm -rf xgboost

Rcheck: Rbuild
	$(R) CMD check --as-cran xgboost*.tar.gz

-include build/*.d
-include build/*/*.d

=== R-package/CMakeLists.txt ===
find_package(LibR REQUIRED)
message(STATUS "LIBR_CORE_LIBRARY " ${LIBR_CORE_LIBRARY})

file(GLOB_RECURSE R_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/src/*.cc
  ${CMAKE_CURRENT_LIST_DIR}/src/*.c)
# Use object library to expose symbols
add_library(xgboost-r OBJECT ${R_SOURCES})
if (ENABLE_ALL_WARNINGS)
  target_compile_options(xgboost-r PRIVATE -Wall -Wextra)
endif (ENABLE_ALL_WARNINGS)
target_compile_definitions(xgboost-r
  PUBLIC
  -DXGBOOST_STRICT_R_MODE=1
  -DXGBOOST_CUSTOMIZE_GLOBAL_PRNG=1
  -DDMLC_LOG_BEFORE_THROW=0
  -DDMLC_DISABLE_STDIN=1
  -DDMLC_LOG_CUSTOMIZE=1
  -DRABIT_CUSTOMIZE_MSG_
  -DRABIT_STRICT_CXX98_)
target_include_directories(xgboost-r
  PRIVATE
  ${LIBR_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_SOURCE_DIR}/dmlc-core/include
  ${PROJECT_SOURCE_DIR}/rabit/include)
target_link_libraries(xgboost-r PUBLIC ${LIBR_CORE_LIBRARY})
if (USE_OPENMP)
  find_package(OpenMP REQUIRED)
  target_link_libraries(xgboost-r PUBLIC OpenMP::OpenMP_CXX OpenMP::OpenMP_C)
endif (USE_OPENMP)
set_target_properties(
  xgboost-r PROPERTIES
  CXX_STANDARD 14
  CXX_STANDARD_REQUIRED ON
  POSITION_INDEPENDENT_CODE ON)

# Get compilation and link flags of xgboost-r and propagate to objxgboost
target_link_libraries(objxgboost PUBLIC xgboost-r)
# Add all objects of xgboost-r to objxgboost
target_sources(objxgboost INTERFACE $<TARGET_OBJECTS:xgboost-r>)

set(LIBR_HOME "${LIBR_HOME}" PARENT_SCOPE)
set(LIBR_EXECUTABLE "${LIBR_EXECUTABLE}" PARENT_SCOPE)

=== R-package/DESCRIPTION ===
Package: xgboost
Type: Package
Title: Extreme Gradient Boosting
Version: 1.7.1.1
Date: 2022-11-03
Authors@R: c(
  person("Tianqi", "Chen", role = c("aut"),
         email = "tianqi.tchen@gmail.com"),
  person("Tong", "He", role = c("aut"),
         email = "hetong007@gmail.com"),
  person("Michael", "Benesty", role = c("aut"),
         email = "michael@benesty.fr"),
  person("Vadim", "Khotilovich", role = c("aut"),
         email = "khotilovich@gmail.com"),
  person("Yuan", "Tang", role = c("aut"),
         email = "terrytangyuan@gmail.com",
         comment = c(ORCID = "0000-0001-5243-233X")),
  person("Hyunsu", "Cho", role = c("aut"),
         email = "chohyu01@cs.washington.edu"),
  person("Kailong", "Chen", role = c("aut")),
  person("Rory", "Mitchell", role = c("aut")),
  person("Ignacio", "Cano", role = c("aut")),
  person("Tianyi", "Zhou", role = c("aut")),
  person("Mu", "Li", role = c("aut")),
  person("Junyuan", "Xie", role = c("aut")),
  person("Min", "Lin", role = c("aut")),
  person("Yifeng", "Geng", role = c("aut")),
  person("Yutian", "Li", role = c("aut")),
  person("Jiaming", "Yuan", role = c("aut", "cre"),
         email = "jm.yuan@outlook.com"),
  person("XGBoost contributors", role = c("cph"),
         comment = "base XGBoost implementation")
  )
Maintainer: Jiaming Yuan <jm.yuan@outlook.com>
Description: Extreme Gradient Boosting, which is an efficient implementation
    of the gradient boosting framework from Chen & Guestrin (2016) <doi:10.1145/2939672.2939785>.
    This package is its R interface. The package includes efficient linear
    model solver and tree learning algorithms. The package can automatically
    do parallel computation on a single machine which could be more than 10
    times faster than existing gradient boosting packages. It supports
    various objective functions, including regression, classification and ranking.
    The package is made to be extensible, so that users are also allowed to define
    their own objectives easily.
License: Apache License (== 2.0) | file LICENSE
URL: https://github.com/dmlc/xgboost
BugReports: https://github.com/dmlc/xgboost/issues
NeedsCompilation: yes
VignetteBuilder: knitr
Suggests:
    knitr,
    rmarkdown,
    ggplot2 (>= 1.0.1),
    DiagrammeR (>= 0.9.0),
    Ckmeans.1d.dp (>= 3.3.1),
    vcd (>= 1.3),
    testthat,
    lintr,
    igraph (>= 1.0.1),
    float,
    crayon,
    titanic
Depends:
    R (>= 3.3.0)
Imports:
    Matrix (>= 1.1-0),
    methods,
    data.table (>= 1.9.6),
    jsonlite (>= 1.0),
RoxygenNote: 7.1.1
SystemRequirements: GNU make, C++14

=== plugin/CMakeLists.txt ===
if (PLUGIN_DENSE_PARSER)
  target_sources(objxgboost PRIVATE ${xgboost_SOURCE_DIR}/plugin/dense_parser/dense_libsvm.cc)
endif (PLUGIN_DENSE_PARSER)

if (PLUGIN_UPDATER_ONEAPI)
  add_library(oneapi_plugin OBJECT
    ${xgboost_SOURCE_DIR}/plugin/updater_oneapi/regression_obj_oneapi.cc
    ${xgboost_SOURCE_DIR}/plugin/updater_oneapi/predictor_oneapi.cc)
  target_include_directories(oneapi_plugin
    PRIVATE
    ${xgboost_SOURCE_DIR}/include
    ${xgboost_SOURCE_DIR}/dmlc-core/include
    ${xgboost_SOURCE_DIR}/rabit/include)
  target_compile_definitions(oneapi_plugin PUBLIC -DXGBOOST_USE_ONEAPI=1)
  target_link_libraries(oneapi_plugin PUBLIC -fsycl)
  set_target_properties(oneapi_plugin PROPERTIES
    COMPILE_FLAGS -fsycl
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED ON
    POSITION_INDEPENDENT_CODE ON)
  if (USE_OPENMP)
    find_package(OpenMP REQUIRED)
    target_link_libraries(oneapi_plugin PUBLIC OpenMP::OpenMP_CXX)
  endif (USE_OPENMP)
  # Get compilation and link flags of oneapi_plugin and propagate to objxgboost
  target_link_libraries(objxgboost PUBLIC oneapi_plugin)
  # Add all objects of oneapi_plugin to objxgboost
  target_sources(objxgboost INTERFACE $<TARGET_OBJECTS:oneapi_plugin>)
endif (PLUGIN_UPDATER_ONEAPI)

# Add the Federate Learning plugin if enabled.
if (PLUGIN_FEDERATED)
  add_subdirectory(federated)
endif (PLUGIN_FEDERATED)

=== debian/changelog ===
xgboost (1.7.1-1) unstable; urgency=medium

  [ Mo Zhou ]
  * New upstream version 1.7.1
  * Rebase existing patches.

  [ Debian Janitor ]
  * Update renamed lintian tag names in lintian overrides.
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields:
    Bug-Database, Bug-Submit, Contact, Repository-Browse.

 -- Mo Zhou <lumin@debian.org>  Wed, 16 Nov 2022 13:57:22 -0500

## xgboost 1.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
-project(xgboost LANGUAGES CXX C VERSION 1.7.1)
+project(xgboost LANGUAGES CXX C VERSION 1.7.2)
 include(cmake/Utils.cmake)
 list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")
 cmake_policy(SET CMP0022 NEW)

=== R-package/DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.1.1
-Date: 2022-11-03
+Version: 1.7.2.1
+Date: 2022-12-08
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -66,5 +66,5 @@
     methods,
     data.table (>= 1.9.6),
     jsonlite (>= 1.0),
-RoxygenNote: 7.1.1
+RoxygenNote: 7.2.1
 SystemRequirements: GNU make, C++14

=== debian/changelog ===
xgboost (1.7.2-1) unstable; urgency=medium

  * New upstream version 1.7.2

 -- Mo Zhou <lumin@debian.org>  Tue, 13 Dec 2022 12:14:43 -0500

=== debian/control ===
Source: xgboost
Section: science
Homepage: https://xgboost.ai/
Priority: optional
Standards-Version: 4.6.0.1
Vcs-Git: https://salsa.debian.org/deeplearning-team/xgboost.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/xgboost
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libdmlc-dev (>= 0.5),
               python3-all,
               python3-setuptools

Package: xgboost
Architecture: any
Depends: libxgboost0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Scalable and Flexible Gradient Boosting (Executable)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost binary executable.

Package: libxgboost-dev
Section: libdevel
Architecture: any
Depends: libxgboost0 (= ${binary:Version}), ${misc:Depends}
Description: Scalable and Flexible Gradient Boosting (Development)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost development files.

Package: libxgboost0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Scalable and Flexible Gradient Boosting (Shared lib)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost shared object.

Package: python3-xgboost
Section: python
Architecture: any
Depends: libxgboost0 (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Description: Scalable and Flexible Gradient Boosting (Python3)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost python3 binding.

## xgboost 1.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
-project(xgboost LANGUAGES CXX C VERSION 1.7.2)
+project(xgboost LANGUAGES CXX C VERSION 1.7.3)
 include(cmake/Utils.cmake)
 list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")
 cmake_policy(SET CMP0022 NEW)

=== R-package/DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.2.1
-Date: 2022-12-08
+Version: 1.7.3.1
+Date: 2023-01-06
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -66,5 +66,5 @@
     methods,
     data.table (>= 1.9.6),
     jsonlite (>= 1.0),
-RoxygenNote: 7.2.1
+RoxygenNote: 7.2.2
 SystemRequirements: GNU make, C++14

=== plugin/federated/CMakeLists.txt ===
# gRPC needs to be installed first. See README.md.
set(protobuf_MODULE_COMPATIBLE TRUE)
set(protobuf_BUILD_SHARED_LIBS TRUE)
find_package(Protobuf CONFIG REQUIRED)
find_package(gRPC CONFIG REQUIRED)
message(STATUS "Found gRPC: ${gRPC_CONFIG}")

# Generated code from the protobuf definition.
add_library(federated_proto federated.proto)
target_link_libraries(federated_proto PUBLIC protobuf::libprotobuf gRPC::grpc gRPC::grpc++)
target_include_directories(federated_proto PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
xgboost_target_properties(federated_proto)

protobuf_generate(
    TARGET federated_proto
    LANGUAGE cpp
    PROTOC_OUT_DIR "${PROTO_BINARY_DIR}")
protobuf_generate(
    TARGET federated_proto
    LANGUAGE grpc
    GENERATE_EXTENSIONS .grpc.pb.h .grpc.pb.cc
    PLUGIN "protoc-gen-grpc=\$<TARGET_FILE:gRPC::grpc_cpp_plugin>"
    PROTOC_OUT_DIR "${PROTO_BINARY_DIR}")

# Wrapper for the gRPC client.
add_library(federated_client INTERFACE)
target_sources(federated_client INTERFACE federated_client.h)
target_link_libraries(federated_client INTERFACE federated_proto)

# Rabit engine for Federated Learning.
target_sources(objxgboost PRIVATE federated_server.cc)
target_link_libraries(objxgboost PRIVATE federated_client "-Wl,--exclude-libs,ALL")
target_compile_definitions(objxgboost PUBLIC -DXGBOOST_USE_FEDERATED=1)

=== tests/buildkite/infrastructure/requirements.txt ===
boto3
cfn_tools

=== debian/changelog ===
xgboost (1.7.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.7.3

 -- Aron Xu <aron@debian.org>  Wed, 01 Feb 2023 16:59:09 +0800

## xgboost 1.7.3.1

=== DESCRIPTION ===
Package: xgboost
Type: Package
Title: Extreme Gradient Boosting
Version: 1.7.3.1
Date: 2023-01-06
Authors@R: c(
  person("Tianqi", "Chen", role = c("aut"),
         email = "tianqi.tchen@gmail.com"),
  person("Tong", "He", role = c("aut"),
         email = "hetong007@gmail.com"),
  person("Michael", "Benesty", role = c("aut"),
         email = "michael@benesty.fr"),
  person("Vadim", "Khotilovich", role = c("aut"),
         email = "khotilovich@gmail.com"),
  person("Yuan", "Tang", role = c("aut"),
         email = "terrytangyuan@gmail.com",
         comment = c(ORCID = "0000-0001-5243-233X")),
  person("Hyunsu", "Cho", role = c("aut"),
         email = "chohyu01@cs.washington.edu"),
  person("Kailong", "Chen", role = c("aut")),
  person("Rory", "Mitchell", role = c("aut")),
  person("Ignacio", "Cano", role = c("aut")),
  person("Tianyi", "Zhou", role = c("aut")),
  person("Mu", "Li", role = c("aut")),
  person("Junyuan", "Xie", role = c("aut")),
  person("Min", "Lin", role = c("aut")),
  person("Yifeng", "Geng", role = c("aut")),
  person("Yutian", "Li", role = c("aut")),
  person("Jiaming", "Yuan", role = c("aut", "cre"),
         email = "jm.yuan@outlook.com"),
  person("XGBoost contributors", role = c("cph"),
         comment = "base XGBoost implementation")
  )
Maintainer: Jiaming Yuan <jm.yuan@outlook.com>
Description: Extreme Gradient Boosting, which is an efficient implementation
    of the gradient boosting framework from Chen & Guestrin (2016) <doi:10.1145/2939672.2939785>.
    This package is its R interface. The package includes efficient linear
    model solver and tree learning algorithms. The package can automatically
    do parallel computation on a single machine which could be more than 10
    times faster than existing gradient boosting packages. It supports
    various objective functions, including regression, classification and ranking.
    The package is made to be extensible, so that users are also allowed to define
    their own objectives easily.
License: Apache License (== 2.0) | file LICENSE
URL: https://github.com/dmlc/xgboost
BugReports: https://github.com/dmlc/xgboost/issues
NeedsCompilation: yes
VignetteBuilder: knitr
Suggests: knitr, rmarkdown, ggplot2 (>= 1.0.1), DiagrammeR (>= 0.9.0),
        Ckmeans.1d.dp (>= 3.3.1), vcd (>= 1.3), testthat, lintr, igraph
        (>= 1.0.1), float, crayon, titanic
Depends: R (>= 3.3.0)
Imports: Matrix (>= 1.1-0), methods, data.table (>= 1.9.6), jsonlite
        (>= 1.0),
RoxygenNote: 7.2.2
SystemRequirements: GNU make, C++14
Packaged: 2023-01-14 20:07:58 UTC; jiamingy
Author: Tianqi Chen [aut],
  Tong He [aut],
  Michael Benesty [aut],
  Vadim Khotilovich [aut],
  Yuan Tang [aut] (<https://orcid.org/0000-0001-5243-233X>),
  Hyunsu Cho [aut],
  Kailong Chen [aut],
  Rory Mitchell [aut],
  Ignacio Cano [aut],
  Tianyi Zhou [aut],
  Mu Li [aut],
  Junyuan Xie [aut],
  Min Lin [aut],
  Yifeng Geng [aut],
  Yutian Li [aut],
  Jiaming Yuan [aut, cre],
  XGBoost contributors [cph] (base XGBoost implementation)
Repository: CRAN
Date/Publication: 2023-01-14 21:20:02 UTC

## xgboost 1.7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
-project(xgboost LANGUAGES CXX C VERSION 1.7.3)
+project(xgboost LANGUAGES CXX C VERSION 1.7.4)
 include(cmake/Utils.cmake)
 list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")
 cmake_policy(SET CMP0022 NEW)

=== Makefile ===
--- 
+++ 
@@ -126,7 +126,6 @@
 	cat R-package/src/Makevars.in|sed '2s/.*/PKGROOT=./' > xgboost/src/Makevars.in
 	cat R-package/src/Makevars.win|sed '2s/.*/PKGROOT=./' > xgboost/src/Makevars.win
 	rm -f xgboost/src/Makevars.win-e   # OSX sed create this extra file; remove it
-	rm -f xgboost/cleanup
 	bash R-package/remove_warning_suppression_pragma.sh
 	bash xgboost/remove_warning_suppression_pragma.sh
 	rm xgboost/remove_warning_suppression_pragma.sh

=== R-package/DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.3.1
-Date: 2023-01-06
+Version: 1.7.4.1
+Date: 2023-02-15
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),

=== doc/requirements.txt ===
sphinx>=5.2.1
mock
sphinx_rtd_theme>=1.0.0
breathe
scikit-learn
sh>=1.12.14
matplotlib>=2.1
graphviz
numpy
recommonmark
xgboost_ray
sphinx-gallery
pyspark
cloudpickle

=== rabit/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)

find_package(Threads REQUIRED)

set(RABIT_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/src/allreduce_base.cc
  ${CMAKE_CURRENT_LIST_DIR}/src/rabit_c_api.cc)

if (RABIT_BUILD_MPI)
  list(APPEND RABIT_SOURCES ${CMAKE_CURRENT_LIST_DIR}/src/engine_mpi.cc)
elseif (RABIT_MOCK)
  list(APPEND RABIT_SOURCES ${CMAKE_CURRENT_LIST_DIR}/src/engine_mock.cc)
else ()
  list(APPEND RABIT_SOURCES ${CMAKE_CURRENT_LIST_DIR}/src/engine.cc)
endif ()

set(RABIT_SOURCES ${RABIT_SOURCES} PARENT_SCOPE)

=== demo/c-api/external-memory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(external-memory-demo LANGUAGES C VERSION 0.0.1)

find_package(xgboost REQUIRED)

add_executable(external-memory-demo external_memory.c)
target_link_libraries(external-memory-demo PRIVATE xgboost::xgboost)

=== debian/changelog ===
xgboost (1.7.4-1) unstable; urgency=medium

  * New upstream version 1.7.4

 -- Mo Zhou <lumin@debian.org>  Fri, 17 Feb 2023 16:32:40 -0500

## xgboost 1.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
-project(xgboost LANGUAGES CXX C VERSION 1.7.4)
+cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
+project(xgboost LANGUAGES CXX C VERSION 1.7.5)
 include(cmake/Utils.cmake)
 list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")
 cmake_policy(SET CMP0022 NEW)
@@ -168,9 +168,6 @@
 
 if (USE_OPENMP)
   if (APPLE)
-    # Require CMake 3.16+ on Mac OSX, as previous versions of CMake had trouble locating
-    # OpenMP on Mac. See https://github.com/dmlc/xgboost/pull/5146#issuecomment-568312706
-    cmake_minimum_required(VERSION 3.16)
     find_package(OpenMP)
     if (NOT OpenMP_FOUND)
       # Try again with extra path info; required for libomp 15+ from Homebrew
@@ -305,3 +302,8 @@
 
 include(CPack)
 
+include(GNUInstallDirs)
+# Install all headers.  Please note that currently the C++ headers does not form an "API".
+install(DIRECTORY ${xgboost_SOURCE_DIR}/include/xgboost
+  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+

=== R-package/DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.4.1
-Date: 2023-02-15
+Version: 1.7.5.1
+Date: 2023-03-29
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -66,5 +66,6 @@
     methods,
     data.table (>= 1.9.6),
     jsonlite (>= 1.0),
-RoxygenNote: 7.2.2
-SystemRequirements: GNU make, C++14
+RoxygenNote: 7.2.3
+Encoding: UTF-8
+SystemRequirements: GNU make, C++17

=== debian/changelog ===
xgboost (1.7.5-1) unstable; urgency=medium

  * New upstream version 1.7.5

 -- Mo Zhou <lumin@debian.org>  Sat, 17 Jun 2023 19:38:21 -0700

## xgboost 1.7.5.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.3.1
-Date: 2023-01-06
+Version: 1.7.5.1
+Date: 2023-03-29
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -52,9 +52,10 @@
 Depends: R (>= 3.3.0)
 Imports: Matrix (>= 1.1-0), methods, data.table (>= 1.9.6), jsonlite
         (>= 1.0),
-RoxygenNote: 7.2.2
-SystemRequirements: GNU make, C++14
-Packaged: 2023-01-14 20:07:58 UTC; jiamingy
+RoxygenNote: 7.2.3
+Encoding: UTF-8
+SystemRequirements: GNU make, C++17
+Packaged: 2023-03-30 18:10:42 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -73,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2023-01-14 21:20:02 UTC
+Date/Publication: 2023-03-30 19:40:02 UTC

## xgboost 1.7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
-project(xgboost LANGUAGES CXX C VERSION 1.7.5)
+project(xgboost LANGUAGES CXX C VERSION 1.7.6)
 include(cmake/Utils.cmake)
 list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")
 cmake_policy(SET CMP0022 NEW)

=== R-package/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 endif (USE_OPENMP)
 set_target_properties(
   xgboost-r PROPERTIES
-  CXX_STANDARD 14
+  CXX_STANDARD 17
   CXX_STANDARD_REQUIRED ON
   POSITION_INDEPENDENT_CODE ON)

=== R-package/DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.5.1
-Date: 2023-03-29
+Version: 1.7.6.1
+Date: 2023-06-16
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),

=== debian/changelog ===
xgboost (1.7.6-1) unstable; urgency=medium

  * New upstream version 1.7.6
  * Add code for the CUDA build in comments for d/{control,rules}
    + Use the correct compiler for CUDA build.
    + Embed gputreeshap (header only lib)
    + Use sed to patch the gputreeshap cmake file
  * Refresh lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Sun, 16 Jul 2023 23:56:48 -0700

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,11 @@
                dh-python,
                libdmlc-dev (>= 0.5),
                python3-all,
-               python3-setuptools
+               python3-setuptools,
+#               nvidia-cuda-toolkit,
+#               nvidia-cuda-toolkit-gcc,
+#               libnccl-dev,
+#               libcub-dev,
 
 Package: xgboost
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export CC=cuda-gcc
#export CXX=cuda-g++

%:
	dh $@ -Scmake --with python3

#execute_before_dh_auto_configure:
#	cp -rv debian/gputreeshap $(CURDIR)
#	# patch the cmake file
#	sed -e '20,$$d' -i gputreeshap/CMakeLists.txt
#
#override_dh_auto_configure:
#	dh_auto_configure -- \
#		-DUSE_CUDA=ON -DBUILD_WITH_CUDA_CUB=ON -DUSE_NCCL=ON

execute_after_dh_auto_install:
	cd python-package; python3 setup.py install --install-layout=deb \
		--root=$(shell pwd)/debian/tmp/
	mkdir -p debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/
	ln -s ../../../../$(DEB_HOST_MULTIARCH)/libxgboost.so.0 \
		debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/libxgboost.so

## xgboost 1.7.6.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.5.1
-Date: 2023-03-29
+Version: 1.7.6.1
+Date: 2023-12-05
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -55,7 +55,7 @@
 RoxygenNote: 7.2.3
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2023-03-30 18:10:42 UTC; jiamingy
+Packaged: 2023-12-05 18:29:45 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -74,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2023-03-30 19:40:02 UTC
+Date/Publication: 2023-12-06 08:50:02 UTC

## xgboost 1.7.7.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.6.1
-Date: 2023-12-05
+Version: 1.7.7.1
+Date: 2024-01-25
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -55,7 +55,7 @@
 RoxygenNote: 7.2.3
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2023-12-05 18:29:45 UTC; jiamingy
+Packaged: 2024-01-25 08:53:23 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -74,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2023-12-06 08:50:02 UTC
+Date/Publication: 2024-01-25 13:10:03 UTC

## xgboost 1.7.8.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.7.1
-Date: 2024-01-25
+Version: 1.7.8.1
+Date: 2024-07-22
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -55,7 +55,7 @@
 RoxygenNote: 7.2.3
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2024-01-25 08:53:23 UTC; jiamingy
+Packaged: 2024-07-24 14:21:15 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -74,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2024-01-25 13:10:03 UTC
+Date/Publication: 2024-07-24 18:40:02 UTC

## xgboost 1.7.9.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.8.1
-Date: 2024-07-22
+Version: 1.7.9.1
+Date: 2025-03-25
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -47,15 +47,15 @@
 NeedsCompilation: yes
 VignetteBuilder: knitr
 Suggests: knitr, rmarkdown, ggplot2 (>= 1.0.1), DiagrammeR (>= 0.9.0),
-        Ckmeans.1d.dp (>= 3.3.1), vcd (>= 1.3), testthat, lintr, igraph
-        (>= 1.0.1), float, crayon, titanic
+        Ckmeans.1d.dp (>= 3.3.1), vcd (>= 1.3), cplm, e1071, caret,
+        testthat, lintr, igraph (>= 1.0.1), float, crayon, titanic
 Depends: R (>= 3.3.0)
 Imports: Matrix (>= 1.1-0), methods, data.table (>= 1.9.6), jsonlite
         (>= 1.0),
-RoxygenNote: 7.2.3
+RoxygenNote: 7.3.2
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2024-07-24 14:21:15 UTC; jiamingy
+Packaged: 2025-03-26 09:17:37 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -74,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2024-07-24 18:40:02 UTC
+Date/Publication: 2025-03-26 14:30:02 UTC

## xgboost 1.7.10.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.9.1
-Date: 2025-03-25
+Version: 1.7.10.1
+Date: 2025-04-22
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -55,7 +55,7 @@
 RoxygenNote: 7.3.2
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2025-03-26 09:17:37 UTC; jiamingy
+Packaged: 2025-04-22 09:49:41 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -74,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2025-03-26 14:30:02 UTC
+Date/Publication: 2025-04-22 11:10:02 UTC

## xgboost 1.7.11.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.7.10.1
-Date: 2025-04-22
+Version: 1.7.11.1
+Date: 2025-05-01
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -55,12 +55,12 @@
 RoxygenNote: 7.3.2
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2025-04-22 09:49:41 UTC; jiamingy
+Packaged: 2025-05-01 10:56:14 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
   Vadim Khotilovich [aut],
-  Yuan Tang [aut] (<https://orcid.org/0000-0001-5243-233X>),
+  Yuan Tang [aut] (ORCID: <https://orcid.org/0000-0001-5243-233X>),
   Hyunsu Cho [aut],
   Kailong Chen [aut],
   Rory Mitchell [aut],
@@ -74,4 +74,4 @@
   Jiaming Yuan [aut, cre],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2025-04-22 11:10:02 UTC
+Date/Publication: 2025-05-15 07:10:02 UTC
